VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3780
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5340
   LinkTopic       =   "Form1"
   ScaleHeight     =   3780
   ScaleWidth      =   5340
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtNumbers 
      Height          =   285
      Left            =   2880
      TabIndex        =   14
      Top             =   2640
      Width           =   2295
   End
   Begin VB.CommandButton cmdRandomizeTextBox 
      Caption         =   "Randomize"
      Height          =   375
      Left            =   2880
      TabIndex        =   13
      Top             =   3240
      Width           =   1095
   End
   Begin VB.CommandButton cmdRandomizeListBox 
      Caption         =   "Randomize"
      Height          =   375
      Left            =   1560
      TabIndex        =   12
      Top             =   3240
      Width           =   1095
   End
   Begin VB.CommandButton cmdRandomizeTextBoxes 
      Caption         =   "Randomize"
      Height          =   375
      Left            =   120
      TabIndex        =   11
      Top             =   3240
      Width           =   1095
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add"
      Height          =   375
      Left            =   1560
      TabIndex        =   10
      Top             =   2520
      Width           =   1095
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   375
      Left            =   1560
      TabIndex        =   9
      Top             =   2040
      Width           =   1095
   End
   Begin VB.ListBox lstNumbers 
      Height          =   1815
      Left            =   1560
      TabIndex        =   8
      Top             =   120
      Width           =   1095
   End
   Begin VB.TextBox txtNumber 
      Height          =   285
      Index           =   7
      Left            =   120
      TabIndex        =   7
      Top             =   2640
      Width           =   1095
   End
   Begin VB.TextBox txtNumber 
      Height          =   285
      Index           =   6
      Left            =   120
      TabIndex        =   6
      Top             =   2280
      Width           =   1095
   End
   Begin VB.TextBox txtNumber 
      Height          =   285
      Index           =   5
      Left            =   120
      TabIndex        =   5
      Top             =   1920
      Width           =   1095
   End
   Begin VB.TextBox txtNumber 
      Height          =   285
      Index           =   4
      Left            =   120
      TabIndex        =   4
      Top             =   1560
      Width           =   1095
   End
   Begin VB.TextBox txtNumber 
      Height          =   285
      Index           =   3
      Left            =   120
      TabIndex        =   3
      Top             =   1200
      Width           =   1095
   End
   Begin VB.TextBox txtNumber 
      Height          =   285
      Index           =   2
      Left            =   120
      TabIndex        =   2
      Top             =   840
      Width           =   1095
   End
   Begin VB.TextBox txtNumber 
      Height          =   285
      Index           =   1
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   1095
   End
   Begin VB.TextBox txtNumber 
      Height          =   285
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
Dim i As Integer
Dim txt As String

    ' Set some initial values.
    For i = txtNumber.lBound To txtNumber.uBound
        txtNumber(i).Text = i
    Next i
    For i = 0 To 5
        lstNumbers.AddItem i
    Next i

    txt = 0
    For i = 1 To 9
        txt = txt & ", " & i
    Next i
    txtNumbers.Text = txt
End Sub

' Randomize the numbers in the TextBoxes.
Private Sub cmdRandomizeTextBoxes_Click()
Dim values() As Integer
Dim i As Integer

    ' Load the valeus into an array.
    ReDim values(txtNumber.lBound To txtNumber.uBound)
    For i = txtNumber.lBound To txtNumber.uBound
        values(i) = Val(txtNumber(i).Text)
    Next i

    ' Randomize.
    RandomizeArray values

    ' Display the results.
    For i = txtNumber.lBound To txtNumber.uBound
        txtNumber(i).Text = values(i)
    Next i
End Sub

' Randomize an array of numbers.
Public Sub RandomizeArray(items() As Integer)
Dim min_item As Integer
Dim max_item As Integer
Dim i As Integer
Dim j As Integer
Dim tmp_value As Integer

    min_item = LBound(items)
    max_item = UBound(items)
    
    For i = min_item To max_item - 1
        ' Randomly assign item number i.
        j = Int((max_item - i + 1) * Rnd + i)
        tmp_value = items(i)
        items(i) = items(j)
        items(j) = tmp_value
    Next i
End Sub

' Add a value to the ListBox.
Private Sub cmdAdd_Click()
Dim new_value As String

    new_value = InputBox("Value")
    If Len(new_value) < 1 Then Exit Sub
    lstNumbers.AddItem Val(new_value)
End Sub

' Clear the ListBox.
Private Sub cmdClear_Click()
    lstNumbers.Clear
End Sub

' Randomize the ListBox.
Private Sub cmdRandomizeListBox_Click()
Dim i As Integer
Dim values() As Integer

    ' Get the values.
    ReDim values(0 To lstNumbers.ListCount - 1)
    For i = 0 To lstNumbers.ListCount - 1
        values(i) = lstNumbers.List(i)
    Next i

    ' Randomize.
    RandomizeArray values

    ' Display the results.
    lstNumbers.Clear
    For i = LBound(values) To UBound(values)
        lstNumbers.AddItem values(i)
    Next i
End Sub

' Randomize the numbers in the single TextBox.
Private Sub cmdRandomizeTextBox_Click()
Dim numbers() As String
Dim i As Integer
Dim values() As Integer
Dim txt As String

    ' Get the values.
    numbers = Split(txtNumbers.Text, ",")
    ReDim values(LBound(numbers) To UBound(numbers))
    For i = LBound(numbers) To UBound(numbers)
        values(i) = Val(numbers(i))
    Next i

    ' Randomize.
    RandomizeArray values

    ' Display the results.
    txt = ""
    For i = LBound(values) To UBound(values)
        txt = txt & ", " & values(i)
    Next i
    If Len(txt) > 0 Then txt = Mid$(txt, 2)
    txtNumbers.Text = txt
End Sub

